<?php


$vars = array();
$vars_cnt = 0;
$shader_data = "#pragma once\n\n";
$shader_compile = "#pragma once\n\n #define SPACEPIGS_SHADERS";

function spaces( $len ){
return '';
	$ret ='                                                                                                             ';
	return substr( $ret, 0,strlen($ret)-$len );
}

function add_shader_data( $fn, $var_name ){
	global $shader_data;
	$shader_data .= "\n\n\nconst static char *$var_name=\n";
	$file_data = file( $fn );
	foreach( $file_data as $line ){
		$line = trim( $line );
		if( substr( $line, 0,2 ) != '//'){
		$len = strlen( $line );
		$shader_data .= '"'.$line.spaces($len).'\n"'."\n";
		}
	}
	$shader_data .='" \n\0";';
	
}

function add_var( $fn ){
	global $vars;
	global $vars_cnt;
	$parts = explode( '.', $fn );
	//print_r( $parts );
	$name = 'SHADER_'.strtoupper  ( $parts[ 0 ]  );
	add_shader_data( "shaders/".$fn, $name.'_'.$parts[1] );
	$vars[ $name ] = 1;
	$vars_cnt++;
}

function to_file( $fn, $data ){
	echo $data;
	$f = fopen( $fn, w );
	fwrite( $f, $data );
	fclose( $f );
	
}
$blah = scandir( 'shaders' );
foreach( $blah as $fn ){
	global $vars;
	global $vars_cnt;
	global $shader_data;
	global $shader_compile;
	$shader_def ="#pragma once\n\n";
	if(( $fn != '.' ) && ($fn != '..')){
		add_var( $fn );
	}
}
	$cnt = 1;
	foreach( $vars as $c => $v ){
		$shader_def .= "\n #define $c \t$cnt";
		$shader_compile .= "\\\n CompileShader( $c, ".$c.'_v, '.$c."_p );";
		$cnt++;
	}
	
	$shader_compile .= "\n\n";
	to_file( 'shader_def.h', $shader_def );
	to_file( 'shader_data.h', $shader_data );
	to_file( 'shader_compile.h', $shader_compile );
	

?>